classification
Title: Fail to build _curses module of Python 3.7.4 on AIX 7.1 using gcc
Type: compile error Stage: resolved
Components: Build Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: BTaskaya, David.Edelsohn, LIU YONG, Michael.Felt, christian.heimes, kadler
Priority: normal Keywords:

Created on 2019-07-31 15:08 by LIU YONG, last changed 2020-11-18 10:11 by christian.heimes. This issue is now closed.

Messages (5)
msg348811 - (view) Author: LIU YONG (LIU YONG) Date: 2019-07-31 15:08
Trying to build Python 3.7.4 on AIX 7.1 using gcc 6.3.0 but failed

Failed to build these modules:
_ctypes               _curses               _curses_panel    


building '_curses' extension
gcc -pthread -Wno-unused-result -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -std=c99 -Wextra -Wno-unused-result -Wno-unused-parameter -Wno-missing-field-initializers -Werror=implicit-function-declaration -I./Include -I. -I/uxx/bxx/Python-3.7.4/Include -I/uxx/bxx/Python-3.7.4 -c /uxx/bxx/Python-3.7.4/Modules/_cursesmodule.c -o build/temp.aix-7.1-3.7/uxx/bxx/Python-3.7.4/Modules/_cursesmodule.o
Modules/ld_so_aix gcc -pthread -bI:Modules/python.exp build/temp.aix-7.1-3.7/uxx/bxx/Python-3.7.4/Modules/_cursesmodule.o -lncurses -o build/lib.aix-7.1-3.7/_curses.so
ld: 0711-317 ERROR: Undefined symbol: .box32
ld: 0711-317 ERROR: Undefined symbol: ._setqiflush
ld: 0711-317 ERROR: Undefined symbol: .setsyx
ld: 0711-317 ERROR: Undefined symbol: ._getsyx
ld: 0711-317 ERROR: Undefined symbol: .w32attroff
ld: 0711-317 ERROR: Undefined symbol: .w32attron
ld: 0711-317 ERROR: Undefined symbol: .w32attrset
ld: 0711-317 ERROR: Undefined symbol: .w32addch
ld: 0711-317 ERROR: Undefined symbol: _unctrl
ld: 0711-317 ERROR: Undefined symbol: .w32insch
ld: 0711-317 ERROR: Undefined symbol: .w32echochar
ld: 0711-317 ERROR: Undefined symbol: .p32echochar
ld: 0711-317 ERROR: Undefined symbol: .initscr32
ld: 0711-317 ERROR: Undefined symbol: wacs_map
ld: 0711-345 Use the -bloadmap or -bnoquiet option to obtain more information.
collect2: error: ld returned 8 exit status
building '_curses_panel' extension
gcc -pthread -Wno-unused-result -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -std=c99 -Wextra -Wno-unused-result -Wno-unused-parameter -Wno-missing-field-initializers -Werror=implicit-function-declaration -I./Include -I. -I/uxx/bxx/Python-3.7.4/Include -I/uxx/bxx/Python-3.7.4 -c /uxx/bxx/Python-3.7.4/Modules/_curses_panel.c -o build/temp.aix-7.1-3.7/uxx/bxx/Python-3.7.4/Modules/_curses_panel.o
In file included from /opt/freeware/include/ncurses/panel.h:42:0,
                 from /uxx/bxx/Python-3.7.4/Modules/_curses_panel.c:17:
/opt/freeware/include/ncurses/curses.h:388:16: error: conflicting types for 'attr_t'
 typedef chtype attr_t;  /* ...must be at least as wide as chtype */
                ^~~~~~
In file included from ./Include/py_curses.h:36:0,
                 from /uxx/bxx/Python-3.7.4/Modules/_curses_panel.c:15:
/opt/freeware/lib/gcc/powerpc-ibm-aix7.1.0.0/6.3.0/include-fixed/curses.h:80:21: note: previous declaration of 'attr_t' was here
         typedef int attr_t;
                     ^~~~~~
msg348898 - (view) Author: LIU YONG (LIU YONG) Date: 2019-08-02 09:57
Additional information of environment 
OS - AIX 7.1 (7100-05-03-1838)
gcc version 6.3.0 (GCC)
ncurses-6.1-2.ppc
ncurses-devel-6.1-2.ppc

I had tried to build Python3.7.3 and Python3.6.9, it hit same errors
It looks like some issue with ncurses version
msg348917 - (view) Author: Michael Felt (Michael.Felt) * Date: 2019-08-02 20:46
Issue36210 needs a back-port to 3.7 and 3.6.
msg381285 - (view) Author: Kevin (kadler) * Date: 2020-11-17 21:17
Both 3.6 and 3.7 are in security only mode so at this point, so if the issue is fixed in newer versions I think this issue could be closed.
msg381322 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2020-11-18 10:11
Closing

As Kevin explained 3.7 only receives security fixes.
History
Date User Action Args
2020-11-18 10:11:47christian.heimessetstatus: open -> closed

type: compile error

nosy: + christian.heimes
messages: + msg381322
resolution: out of date
stage: resolved
2020-11-17 21:17:22kadlersetnosy: + kadler
messages: + msg381285
2020-03-31 21:24:00BTaskayasetnosy: + BTaskaya
2019-08-02 20:46:39Michael.Feltsetmessages: + msg348917
2019-08-02 19:59:56taleinatsetnosy: + Michael.Felt
2019-08-02 09:57:14LIU YONGsetmessages: + msg348898
versions: + Python 3.6
2019-07-31 15:30:34vstinnersetnosy: + David.Edelsohn
2019-07-31 15:30:11vstinnersettitle: Fail to build Python 3.7.4 on AIX 7.1 using gcc -> Fail to build _curses module of Python 3.7.4 on AIX 7.1 using gcc
2019-07-31 15:08:46LIU YONGcreate